

var settings = { hostlist: [] };

const storage_settings_key = 'settings';
function loadStorageSettings() {
  chrome.storage.sync.get( [ storage_settings_key ], function ( result ) {
    settings = result[storage_settings_key];

    if ( settings ) {

    }
    else {
      settings = {};
    }

    if ( settings.hostlist ) {

    }
    else {
      settings.hostlist = [];
    }
  } );
}
function saveStorageSettings() {
  chrome.storage.sync.set( { [storage_settings_key]: settings }, function ( _ ) {
    
  } );
}

loadStorageSettings();

chrome.webNavigation.onBeforeNavigate.addListener(
  function (details) {
    const tabId = details.tabId;
    const tabUrl = details.url;

    const host = settings.hostlist.find( p => tabUrl.startsWith(`http://${p}`) || tabUrl.startsWith(`https://${p}`) );

    const isMatchHost = !!host;

    if ( isMatchHost ) {

      //const pattern = '<all_urls>';
      const pattern = `*://${ host }/*`;
      chrome.tabs.query( { url: pattern }, function ( openTabs ) {

        const findedTab = (openTabs || []).find( p => p.url.indexOf( host ) > -1 );
        if ( findedTab && findedTab.id !== tabId ) {

          chrome.tabs.remove( tabId );
          chrome.tabs.update( findedTab.id, { active: true } );
          chrome.tabs.executeScript( findedTab.id, {
            code: `document.dispatchEvent(new CustomEvent('extension_event', {detail: { type: 'openurl', data: {url: '${ tabUrl }'}}}));`
          } );
         

        }
      } );
    }
  }
);

chrome.runtime.onMessage.addListener( data => {
  if ( data.type === 'settings_request' ) {
    chrome.runtime.sendMessage( '', {
      type: 'settings_response',
      data: settings
    } )
  }
  else if ( data.type === 'settings_save' ) {
    settings = data.data;
    saveStorageSettings();
    chrome.runtime.sendMessage( '', {
      type: 'settings_response',
      data: settings
    } )
  }
} );