

document.addEventListener( 'DOMContentLoaded', function () {

  const button_saveSettings = document.getElementById( 'button_saveSettings' );
  const hostlist_container = document.getElementById( 'hostlist_container' );
  const hostlist_input = document.getElementById( 'hostlist_input' );

  function saveSettings() {
    const hostList = [];
    const hostInputs = hostlist_container.querySelectorAll( 'input[type="hidden"]' );
    for ( let i = 0; i < hostInputs.length; i++ ) {
      hostList.push( hostInputs.item( i ).value );
    }

    const newHost = hostlist_input.value;
    if ( newHost && hostList.indexOf( newHost ) == -1 ) {
      hostList.push( newHost );
    }
    hostlist_input.value = '';

    const settings = {
      hostlist: hostList
    };

    chrome.runtime.sendMessage( '', {
      type: 'settings_save',
      data: settings
    } );
  }
    
  chrome.runtime.onMessage.addListener( data => {
    if ( data.type === 'settings_response' ) {
      const settings = data.data;

      let containerHtml = '';
      for ( const host of settings.hostlist ) {
        containerHtml += `<div><input type="hidden" value="${host}"><span>${host}</span><span class="remove-host" style="cursor:pointer;">&nbsp;[-]</span></div>`;
      }
      hostlist_container.innerHTML = containerHtml;
    }
  } );

  chrome.runtime.sendMessage( '', {
    type: 'settings_request'
  } );

  hostlist_container.addEventListener( 'click', ( $event ) => {
    if ( $event && $event.target && $event.target.classList.contains( 'remove-host' ) ) {
      $event.target.parentNode.remove();
      saveSettings();
    }
  } );

  button_saveSettings.addEventListener( 'click', () => {
    saveSettings();
  } );
	
}, false );